Bug 1158522 - ShellCheck FTBS on ppc(64(le)), s390(x) and aarch64
Summary: ShellCheck FTBS on ppc(64(le)), s390(x) and aarch64
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: ShellCheck
Version: 21
Hardware: Unspecified
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Jens Petersen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: ZedoraTracker PPCTracker F-ExcludeArch-ppc64le, PPC64LETracker
TreeView+ depends on / blocked
 
Reported: 2014-10-29 14:47 UTC by Jakub Čajka
Modified: 2014-12-18 06:12 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-12-06 10:33:50 UTC


Attachments (Terms of Use)
Patch disabling tests (1.83 KB, patch)
2014-10-29 14:47 UTC, Jakub Čajka
no flags Details | Diff

Description Jakub Čajka 2014-10-29 14:47:09 UTC
Created attachment 951813 [details]
Patch disabling tests

Package fails to build on up mentioned architectures with:

.
.
.
+ ./Setup build
Building ShellCheck-0.3.4...
Preprocessing library ShellCheck-0.3.4...
ShellCheck/Analytics.hs:36:8:
    Could not find module `Test.QuickCheck.All'
    Perhaps you meant
      Test.QuickCheck.Gen (from QuickCheck-2.5.1.1)
      Test.QuickCheck.Poly (from QuickCheck-2.5.1.1)
      Test.QuickCheck (from QuickCheck-2.5.1.1)
    Use -v to see a list of the files searched for.
.
.
.

Removing "import Test.QuickCheck.All (quickCheckAll)" and enabling ARM patch, makes build continue, but then fails building tests. Removing tests from Cabal 
file makes build pass.

Probably related to 1144919.

In attachment is patch with changes. 
Similar changes are used by Debian(nearly identical to patch used on ARM): http://ftp.debian.org/debian/pool/main/s/shellcheck/shellcheck_0.3.4-3.debian.tar.xz

Comment 1 Dridi Boukelmoune 2014-11-02 16:45:51 UTC
Thanks for the patch, I have applied it on relevant architectures and scratch builds run fine, except on rawhide.

It looks like a recent bump of perl (5.20) left a bunch of modules behind (5.18) and those are pulled by koji/mock. Once I get it building on rawhide, I'll an update to all maintained branches.

Comment 2 Dan Horák 2014-11-04 07:55:42 UTC
Please don't wait for rawhide with the new builds if it is broken on secondary arches (s390, ppc). It can take weeks or maybe months before we get everything cleaned up because we are still focusing on f21. If it is on primary then please report bugs or let us know what is broken as primary shouldn't have broken Perl. The broken builds in f21 and others cost us resources.

Comment 3 Jens Petersen 2014-11-04 09:16:11 UTC
Dan, don't worry - Dridi built for all releases *except* rawhide :)

But unfortunately my initial build fix was only for ARM.

Comment 4 Dridi Boukelmoune 2014-11-04 19:13:51 UTC
Jens, actually I only scratch built, so nothing's been done in git yet outside of my laptop.

My understanding is that I should push the upgrade anyway, but in order not to break the upgrade path, should I also push the package to rawhide even though it doesn't build yet ?

It doesn't actually get to the build phase, and I suspect it would build just fine if it weren't for missing Perl dependencies in the build root.

Comment 5 Jens Petersen 2014-11-06 10:57:26 UTC
I opened https://github.com/koalaman/shellcheck/issues/254 upstream
to ask removing the QuickCheck's from the main src itself into tests/.

(In reply to Dridi Boukelmoune from comment #4)
> Jens, actually I only scratch built, so nothing's been done in git yet
> outside of my laptop.

Ah I see, sorry I think I was confusing this with the earlier ARM failure
and/or upgrade to 0.3.4.

In the meantime I had pushed a change to master to disable tests on more archs,
but thanks Jakub I see my original patch had forgotten to remove
the QuickCheck imports which caused my latest to still fail on other archs.

> My understanding is that I should push the upgrade anyway, but in order not
> to break the upgrade path, should I also push the package to rawhide even
> though it doesn't build yet ?

You mean to git?  Yes.

Sorry - didn't mean to interfere, but since I already did
half the work badly - I thought I better fix up git master
to be right.

I think the latest commit ba15a85 should now build everywhere (on f21).

> It doesn't actually get to the build phase, and I suspect it would build
> just fine if it weren't for missing Perl dependencies in the build root.

You won't be able to build for Rawhide currently anyway since
llvm-3.5 went into Rawhide recently which breaks ghc on ARM (bug 1161049). :-(

Sorry for getting in the way. :-)

Comment 6 Jens Petersen 2014-11-06 11:02:54 UTC
A few more comments: note that I disabled tests everywhere for now
since I feel it is wrong to link QuickCheck into the binary
and library anyway: it should only be used for running the build tests.

http://pkgs.fedoraproject.org/cgit/ShellCheck.git/commit/?id=ba15a85ee6fdf9fd68ede8e76a42cb9ebb315588

Scratch builds for f21:
http://koji.fedoraproject.org/koji/taskinfo?taskID=8053840
http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=2172647

Comment 7 Fedora Update System 2014-11-07 05:48:11 UTC
ShellCheck-0.3.4-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/ShellCheck-0.3.4-2.fc21

Comment 8 Fedora Update System 2014-11-07 05:48:18 UTC
ShellCheck-0.3.4-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ShellCheck-0.3.4-2.fc20

Comment 9 Fedora Update System 2014-11-07 05:49:26 UTC
ShellCheck-0.3.4-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ShellCheck-0.3.4-2.fc19

Comment 10 Fedora Update System 2014-11-09 15:45:39 UTC
Package ShellCheck-0.3.4-2.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing ShellCheck-0.3.4-2.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-14486/ShellCheck-0.3.4-2.fc20
then log in and leave karma (feedback).

Comment 11 Fedora Update System 2014-12-06 10:33:50 UTC
ShellCheck-0.3.4-2.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2014-12-12 04:12:04 UTC
ShellCheck-0.3.4-2.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2014-12-18 06:12:03 UTC
ShellCheck-0.3.4-2.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.